/*
 * Hash.hpp
 *
 *  Created on: 22.09.2010
 *      Author: stephan
 */

#ifndef HISTORYBUFFER_HPP_
#define HISTORYBUFFER_HPP_
#define historybuffer_hpp_version	 "$Revision: 1.1 $"

#include <vector>
#include <stdint.h>
#include "Assertion.hpp"

using std::vector;

template<class I, class T>
class HistoryBuffer{
	uint32_t	next;
	bool		full;
	vector<I> 	buff;
	T			total;

public:
	HistoryBuffer(uint32_t sz=1):next(0),full(false),total(0){
								asrt(sz>0); buff.resize(sz);}
	bool enoughData()	const 	{return full;}
	void clear()				{next=0; total=0; full=false;}
	void resize(uint32_t sz)	{asrt(sz>0); clear(); buff.resize(sz);}
	T	getTotal()		const	{asrt(full); return total;}
	T	getAvg()		const	{asrt(full); asrt(buff.size() > 0); return total / buff.size();}

	void keep(const I& e){
		asrt(next < buff.size());

		if(full){ asrt(total >= buff[next]);
			total 	-= buff[next];}

		buff[next] 	=  e;
		total 		+= e;

		if(++next >= buff.size()){
			next = 0; full = true;}
	}
};



#endif
